<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

var dateIsValid = [];
var commentsIsValid = true;

function init()
{
	var frm = document.forms['reggie'];
	var bioplates = getCDnaBioPlates();
	
	// Load existing cDNA plates not yet registered
	var plates = frm.bioplate;
	if (bioplates != null && bioplates.length > 0)
	{
		for (var i=0; i < bioplates.length; i++)
		{
			var bioplate = bioplates[i];
			var option = new Option(bioplate.name, bioplate.id);
			plates.options[plates.length] = option;
		}
		bioplateIsValid = true;
		setInputStatus('bioplate', '', 'valid');
		outcomeOnChange();
	}
	else
	{
		var msg = 'No cDNA bioplates available for processing.';
		setFatalError(msg);
		return;
	}
	
	frm.bioplate.focus();
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	setCurrentStep(currentStep);
}

function getCDnaBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading histology work lists...');
		var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetUnprocessedPlates&plateType=CDNA';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.bioplates;
}

function outcomeOnChange()
{
	var frm = document.forms['reggie'];
	Main.addOrRemoveClass(frm['comments'], 'required', document.getElementById('outcomeFailed').checked);
	commentsOnChange();
}


function gotoStep2()
{
	var frm = document.forms['reggie'];	
	frm.bioplate.disabled = true;
	frm.outcome[0].disabled = true;
	frm.outcome[1].disabled = true;
	
	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.hide('gonext');
	Main.show('gocancel');
	Main.show('goregister');
	
	// Load cDNA protocols
	var cdnaProtocols = getProtocols('CDNA_PROTOCOL');
	for (var i = 0; i < cdnaProtocols.length; i++)
	{
		var protocol = cdnaProtocols[i];
		frm.cdnaProtocol[frm.cdnaProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('cdnaProtocol', '', 'valid');
	}
	if (frm.cdnaProtocol.length == 0)
	{
		frm.cdnaProtocol[0] = new Option('- none -', '');
	}

	if (document.getElementById('outcomeFailed').checked)
	{
		setInnerHTML('gonext.message', '<input type="checkbox" name="verifyFailure" onclick="verifyFailureOnClick()"> Check to verify registration of failure');
		Main.addClass(document.getElementById('goregister'), 'disabled');
	}

	frm.synthesisDate.focus();
}


function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}


function commentsOnChange()
{
	var frm = document.forms['reggie'];
	commentsIsValid = false;
	setInputStatus('comments', '', '');
	
	var comments = frm.comments.value;
	
	if (comments == '' && document.getElementById('outcomeFailed').checked)
	{
		setInputStatus('comments', 'Missing', 'invalid');
		return;
	}

	setInputStatus('comments', '', 'valid');
	commentsIsValid = true;
}

function cdnaDateOnChange()
{
	var frm = document.forms['reggie'];
	cdnaDateIsValid = false;
	setInputStatus('cdnaDate', '', '');
	
	var cdnaDate = frm.cdnaDate.value;
	
	if (cdnaDate == '')
	{
		setInputStatus('cdnaDate', 'Missing', 'invalid');
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	cdnaDate = autoFillDate(cdnaDate);
	frm.cdnaDate.value = cdnaDate;
	
	if (!Dates.isDate(cdnaDate, 'yyyyMMdd'))
	{
		setInputStatus('cdnaDate', 'Not a valid date', 'invalid');
		return;
	}
	
	setInputStatus('cdnaDate', '', 'valid');
	cdnaDateIsValid = true;
}

function step2IsValid()
{
	var frm = document.forms['reggie'];
	if (!commentsIsValid) return false;
	
	if (dateIsValid['synthesisDate'] == false) return false;
	if (document.getElementById('outcomeFailed').checked && !frm.verifyFailure.checked) return false;
	
	return true;
}

function verifyFailureOnClick()
{
	var frm = document.forms['reggie'];
	var checked = frm.verifyFailure.checked;
	Main.addOrRemoveClass(document.getElementById('goregister'), 'disabled', !checked);
}

function goRegister()
{
	if (!step2IsValid()) return;

	var frm = document.forms['reggie'];
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	Main.addClass(document.getElementById('step.2.section'), 'disabled');

	frm.synthesisDate.disabled = true;
	frm.synthesisOperator.disabled = true;
	frm.cdnaProtocol.disabled = true;
	frm.comments.disabled = true;
	
	var submitInfo = {};
	submitInfo.bioplate = parseInt(frm.bioplate.value, 10);
	submitInfo.failed = document.getElementById('outcomeSuccess').checked ? false : true;
	submitInfo.cdnaProtocol = parseInt(frm.cdnaProtocol.value, 10);
	submitInfo.synthesisDate = frm.synthesisDate.value;
	submitInfo.synthesisOperator = frm.synthesisOperator.value;
	submitInfo.comments = frm.comments.value;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../MRna.servlet?ID=<%=ID%>&cmd=ImportCDnaResults';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('done');
	Main.show('gorestart');
	
}

function dateOnChange(dateField)
{
	var frm = document.forms['reggie'];

	setInputStatus(dateField, '', '');
	dateIsValid[dateField] = true;
	var date = frm[dateField].value;

	if (date == '')
	{
		setInputStatus(dateField, 'Missing date', 'warning');
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	date = autoFillDate(date);
	frm[dateField].value = date;
	if (!Dates.isDate(date, 'yyyyMMdd'))
	{
		setInputStatus(dateField, 'Not a valid date', 'invalid');
		dateIsValid[dateField] = false;
		return;
	}
	
	setInputStatus(dateField, '', 'valid');
}

function setDate(frmName, dateField, date)
{
	var frm = document.forms['reggie'];
	frm[dateField].value = date;
	dateOnChange(dateField);
	frm[dateField].focus();
}


</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="cDNA registration" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select cDNA bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">cDNA bioplate</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="bioplate" id="bioplate"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select an existing cDNA bioplate. The list contain all cDNA bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<input type="radio" name="outcome" id="outcomeSuccess" 
						onchange="outcomeOnChange()" checked><label for="outcomeSuccess">Success</label> - continue with library preparation<br>
					<input type="radio" name="outcome" id="outcomeFailed" 
						onchange="outcomeOnChange()"><label for="outcomeFailed">Failure</label> - no further processing to libraries
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Failure</b> option if further processing to cDNA is not possible.
					No child cDNA plate will be created and existing RNA will be flagged and added
					to the <b>Flagged RNA</b> list.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
			
			
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle">cDNA preparation information</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Step</td>
				<td style="width: 11em;"><b>Date</b></td>
				<td><b>Operator</b></td>
				<td class="status"></td>
				<td class="help" rowspan="2">
					Enter date and operator for each step in the cDNA preparation.
					(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr>
				<td class="subprompt">Synthesis</td>
				<td>
					<input type="text" name="synthesisDate" maxlength="10" style="width: 8em;"
						onblur="dateOnChange('synthesisDate')" onkeypress="focusOnEnter(event, 'synthesisOperator')">
						<base:icon 
							onclick="Dates.selectDate('Synthesis date', 'reggie', 'synthesisDate', 'setDate', 'yyyyMMdd')"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td>
					<input type="text" name="synthesisOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 95%;" maxlength="255" onkeypress="focusOnEnter(event, 'cdnaProtocol')">
				</td>
				<td class="status" id="synthesisDate.status"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input" colspan="2"><select style="width:90%;" name="cdnaProtocol" id="cdnaProtocol" 
					onkeypress="focusOnEnter(event, 'comments')"></select></td>
				<td class="status" id="cdnaProtocol.status"></td>
				<td class="help"><span id="cdnaProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used in the cDNA preparation.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input" colspan="2"><textarea rows="4" cols="50" name="comments" value="" style="width:90%;" onblur="commentsOnChange()"></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help"><span id="comments.message" class="message" style="display: none;"></span>Comments about the cDNA preparation.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>