<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	boolean isAdmin = user.getId() == SystemItems.getId(User.ROOT);
	boolean isPatientCurator = false;
	if (!isAdmin)
	{
		try
		{
			Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
			isAdmin = sc.isMemberOf(admin);
		}
		catch (RuntimeException ex)
		{}
	}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
	
	final String caseName = request.getParameter("caseName");
	final String pageType = Values.getString(request.getParameter("pageType"), "default");
	
	boolean iframe = "iframe".equals(pageType);
	boolean popup = "popup".equals(pageType);
	boolean fullPage = !iframe && !popup;
%>
<base:page type="<%=pageType %>" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<link rel="stylesheet" type="text/css" href="../css/case_summary.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = false;
var ID = '<%=ID%>';
var caseName= '';

var TRUNCATE_SIZE = [-1, 30, 20, 15];

// Style the message as a warning message
function asWarning(message)
{
	message = '<span class="warning">' + message + '</span>';
	return message;
}

// Style the message as a 'no information' message
function asNoInfo(message)
{
	message = '<span class="no-info">' + message + '</span>';
	return message;
}

// Generte a 'Missing' warning if the value is missing
function warnIfMissing(value)
{
	var message = value ? value : asWarning('Missing');
	return message;
}

// Style the message as a 'flag information' message
function asFlagInfo(message, icon)
{
	message = '<span class="flag-info">' + message + '&nbsp;' + '<img src="../images/'+icon+'"></span>';
	return message;
}

// Style the message as a 'fail information' message
function asFailInfo(message, icon)
{
	message = '<span class="fail-info">' + message + '&nbsp;' + '<img src="../images/'+icon+'"></span>';
	return message;
}

function asConsent(consent, consentDate)
{
	var warn = !consent || !consentDate;
	var message;
	if (!consent)
	{
		message = 'Missing' + (consentDate ? ', ' + consentDate : '');
	}
	else
	{
		message = consent + ', ' + (consentDate ? consentDate : 'Missing date');
		
	}
	return warn ? asWarning(message) : message
}

function asBioPlateLocation(well)
{
	if (!well) return '';
	var plate = well.bioPlate;
	var text = makeLink('BIOPLATE', plate)  + ' ' + well.location;
	if (plate.storage)
	{
		var storage = plate.storage;
		var tmp = [];
		if (storage.name) tmp[tmp.length] = storage.name;
		if (storage.section) tmp[tmp.length] = 'section: ' +storage.section;
		if (storage.tray) tmp[tmp.length] = 'tray: ' +storage.tray;
		if (storage.position) tmp[tmp.length] = 'position: ' +storage.position;

		text = '<span class="more-info" title="' + tmp.join('; ')+'">' + text + ' </span>';
	}
	return text;
}

// Set the content of the element 'id' to the value
function setValue(id, value)
{
	setInnerHTML(id, value);
}

function truncate(value, maxLength)
{
	if (!value) return value;
	if (maxLength > 2 && value.length > maxLength) 
	{
		var tmp = '<span class="truncated" title="'+value+'">'+value.substring(0, maxLength-2) + '...</span>';
		value = tmp;
	}
	return value;
}

function addColumn(id, value)
{
	var tr = document.getElementById(id);
	var td = document.createElement('td');
	if (tr.hasAddedColumns)
	{
		td.className = 'extra-column';
		tr.childNodes[tr.childNodes.length-1].className += ' fixed-column';
	}
	tr.hasAddedColumns = true;
	if (value != null)
	{
		td.innerHTML = value == '' ? '&nbsp;' : value;
		if (tr.className.indexOf('dynamic-column') >= 0)
		{
			tr.style.display = 'table-row';
		}
	}
	else
	{
		td.innerHTML = '&nbsp;';
	}
	tr.appendChild(td);
}

function makeLink(itemType, item, maxLength)
{
	var link = '';
	if (item)
	{
		var name = truncate(item.name, maxLength);
		if (item.id)
		{
			link = '<span class="link" onclick="Main.itemOnClick(event, ID, \''+itemType+'\', '+item.id+', '+item.editable+')">';
			link += name + '</span>';
		}
		else
		{
			link = name;
		}
	}
	return link;
}

function asFileLink(file, icon)
{
	var link = '';
	if (file)
	{
		link = '<span class="link filelink" onclick="Main.viewFile(ID,'+file.id+')"><img src="../images/'+icon+'"></span>';
	}
	return link;
}

function asCaseList(allCases, mainCase)
{
	var html = '';
	for (var i = 0; i < allCases.length; i++)
	{
		var cse = allCases[i];
		if (html != '') html += ', ';
		if (cse != mainCase)
		{
			html += '<span class="link" onclick="caseSummary(\''+cse + '\')" title="Show summary of case #'+cse+'">'+cse+'</span>';
		}
		else
		{
			html += '<b>' + cse + '</b>';
		}
	}
	return allCases.length > 1 ? html : null;
}

function formatDate(value)
{
	if (!value) return '';
	if (value.length == 8)
	{
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	return value;
}


function formatDateTime(value, compareToDate)
{
	if (!value) return '';
	if (value.length == 8)
	{
		value = formatDate(value);
	}
	else if (value.length == 13)
	{
		// If the compareToDate is the same day as the 'value' date, skip the date and replace with white-space
		if (compareToDate && value.substr(0, 8) == compareToDate.substr(0, 8))
		{
			value = '<span class="invisible">'+formatDate(value.substr(0, 8)) + '</span> ' + value.substr(9, 2) + ':'+value.substr(11, 2)
		}
		else
		{
			value = formatDate(value.substr(0, 8)) + ' ' + value.substr(9, 2) + ':'+value.substr(11, 2);
		}
	}
	return value;
}

function formatQuantity(value, scale, unit)
{
	var result = '';
	if (value != null)
	{
		if (scale) value = value / scale;
		result = formatNumber(value, unit, 2);
	}
	return result;
}

function asPercent(value)
{
	var result = '';
	if (value != null)
	{
		result = value + '%';
	}
	return result;
}

function init()
{
	var frm = document.forms['reggie'];
	if (frm.caseName) frm.caseName.focus();
	
	caseName = '<%=HTML.javaScriptEncode(caseName)%>';
	var isAdmin = <%=isAdmin ? "true" : "false"%>;
	var isPatientCurator = <%=isPatientCurator ? "true" : "false"%>;
	
	var url = '../CaseSummary.servlet?ID=<%=ID%>&cmd=GetCaseInfo';
	url += '&caseName=<%=HTML.urlEncode(caseName)%>';
	var request = Ajax.getXmlHttpRequest();
	request.open("GET", url, false);
	request.send(null);
	
	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	Main.show('all-info');
	
	var caseInfo = response.caseInfo;
	var site = response.site;
	initSections(response.sections);
	var consentOk = true;
	
	if (caseInfo)
	{
		// Use returned case name, as it may have been found from personal number
		caseName = caseInfo.name;
		// Update header text to use the potentially changed case name
		if (document.getElementById('path-case-summary') != null)
		{
			document.getElementById('path-case-summary').innerHTML = 'Case summary - ' + escape(caseName);
		}
		if (document.getElementById('path-case-summary-popup') != null)
		{
			document.getElementById('path-case-summary-popup').innerHTML = 'Case summary - ' + escape(caseName);
		}
		consentOk = !caseInfo.consent || caseInfo.consent == 'Yes';
		addColumn('case.name', makeLink('SAMPLE', caseInfo));
		addColumn('case.registrationDate', formatDate(caseInfo.registrationDate));
		addColumn('case.site', site ? site.name : null);
		addColumn('case.consent', asConsent(caseInfo.consent, formatDate(caseInfo.consentDate)));
		addColumn('case.laterality', consentOk ? warnIfMissing(caseInfo.laterality) : null);
		addColumn('case.comment', caseInfo.comment);
	}
	else
	{
		addColumn('case.name', asNoInfo('No case information has been registered'));
		Main.hide('case-details');
	}
	
	var patient = response.patient;
	if (patient)
	{
		if (consentOk)
		{
			addColumn('patient.name', makeLink('BIOSOURCE', patient));
			addColumn('patient.registrationDate', formatDate(patient.registrationDate));
			addColumn('patient.personalNumber', warnIfMissing(patient.personalNumber));
			addColumn('patient.allFirstNames', warnIfMissing(patient.allFirstNames));
			addColumn('patient.familyName', warnIfMissing(patient.familyName));
			addColumn('patient.gender', patient.gender);
			addColumn('patient.allCases', asCaseList(patient.allCases, caseName));
		}
		else
		{
			Main.hide('patient-info');
		}
	}
	else
	{
		addColumn('patient.name', asNoInfo('No patient information has been registered'));
		Main.hide('patient-details');
	}
	
	var blood = consentOk ? response.blood : null;
	if (blood && blood.length > 0)
	{
		for (var i = 0; i < blood.length; i++)
		{
			var b = blood[i];
			addColumn('blood.name', makeLink('SAMPLE', b));
			addColumn('blood.registrationDate', formatDate(b.registrationDate));
			addColumn('blood.consent', asConsent(b.consent, formatDate(b.consentDate)));
			addColumn('blood.bloodSample', b.bloodSample);
			addColumn('blood.samplingDate', warnIfMissing(formatDateTime(b.samplingDate)));
			addColumn('blood.freezerDate', warnIfMissing(formatDateTime(b.freezerDate, b.samplingDate)));
			addColumn('blood.serum', b.serum);
			addColumn('blood.comment', b.comment);
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('blood.name', asNoInfo('No blood information has been registered'));
			Main.hide('blood-details');
		}
		else
		{
			Main.hide('blood-info');
		}
	}
	
	var specimen = consentOk ? response.specimen : null;
	var noSpecimen = consentOk ? response.noSpecimen : null;
	var numSpecimenOrNoSpecimen = 0;
	if (specimen && specimen.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(specimen.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < specimen.length; i++)
		{
			var s = specimen[i];
			addColumn('specimen.name', makeLink('SAMPLE', s));
			addColumn('specimen.registrationDate', formatDate(s.registrationDate));
			addColumn('specimen.storageBox', asBioPlateLocation(s.bioWell));
			addColumn('specimen.laterality', warnIfMissing(s.laterality));
			addColumn('specimen.samplingDate', warnIfMissing(formatDateTime(s.samplingDate)));
			addColumn('specimen.rnaLaterDate', warnIfMissing(formatDateTime(s.rnaLaterDate, s.samplingDate)));
			addColumn('specimen.pad', warnIfMissing(s.pad));
			addColumn('specimen.biopsyType', s.biopsyType);
			addColumn('specimen.remainingQuantity', formatQuantity(s.remainingQuantity, 1000, ' mg'));
			addColumn('specimen.originalQuantity', formatQuantity(s.originalQuantity, 1000, ' mg'));
			addColumn('specimen.nofPieces', s.nofPieces);
			addColumn('specimen.partitionComment', truncate(s.partitionComment, truncateAt));
			addColumn('specimen.comment', truncate(s.comment, truncateAt));
			numSpecimenOrNoSpecimen++;
		}
		if (!noSpecimen || noSpecimen.length == 0)
		{
			Main.hide('nospecimen-info');
		}
	}
	if (noSpecimen && noSpecimen.length > 0)
	{
		for (var i = 0; i < noSpecimen.length; i++)
		{
			var s = noSpecimen[i];
			addColumn('nospecimen.name', makeLink('SAMPLE', s));
			addColumn('nospecimen.registrationDate', formatDate(s.registrationDate));
			addColumn('nospecimen.laterality', warnIfMissing(s.laterality));
			addColumn('nospecimen.samplingDate', warnIfMissing(formatDate(s.samplingDate)));
			addColumn('nospecimen.pad', warnIfMissing(s.pad));
			addColumn('nospecimen.reasonIfNoSpecimen', s.reasonIfNoSpecimen);
			addColumn('nospecimen.comment', truncate(s.comment, truncateAt));
			numSpecimenOrNoSpecimen++;
		}
		if (!specimen || specimen.length == 0)
		{
			addColumn('specimen.name', asNoInfo('No specimen received; see below for details'));
			Main.hide('specimen-details');
		}
	}
	if (numSpecimenOrNoSpecimen == 0)
	{
		if (consentOk)
		{
			addColumn('specimen.name', asNoInfo('No specimen information has been registered'));
			Main.hide('specimen-details');
		}
		else
		{
			Main.hide('specimen-info');	
		}
		Main.hide('nospecimen-info');
	}
	
	var histology = consentOk ? response.histology : null;
	if (histology && histology.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(histology.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < histology.length; i++)
		{
			var h = histology[i];
			addColumn('histology.name', makeLink('SAMPLE', h));
			addColumn('histology.registrationDate', formatDate(h.registrationDate));
			addColumn('histology.partitionDate', formatDate(h.partitionDate));
			addColumn('histology.usedQuantity', formatQuantity(h.originalQuantity, 1000, ' mg'));

			var embedded = h.embedDate ? true : false;
			addColumn('histology.embedded', embedded ? formatDate(h.embedDate) : 'No');
			addColumn('histology.embedProtocol', embedded ? makeLink('PROTOCOL', h.embedProtocol, truncateAt) : null);
			addColumn('histology.paraffinBlock', embedded ? asBioPlateLocation(h.bioWell) : null);
			addColumn('histology.storageBox', embedded ? null : asBioPlateLocation(h.bioWell));

			var stained = h.stainDate ? true : false;
			var bestStain = stained ? h.bestStain : null;
			var scored = bestStain && bestStain.ScoreComplete != null ? true : false;
				
			addColumn('histology.stained', stained ? formatDate(h.stainDate) : 'No');
			addColumn('histology.nofSlides', stained ? h.numStains : null);
			addColumn('histology.heGlass', stained ? asBioPlateLocation(bestStain.bioWell) : null);
			addColumn('histology.stainProtocol', stained ? makeLink('PROTOCOL', h.stainProtocol, truncateAt) : null);
			
			addColumn('histology.scored', scored ? (bestStain.ScoreComplete ? 'Complete' : 'In progress') : 'No');
			addColumn('histology.scoreInvasiveCancer', scored ? asPercent(bestStain.ScoreInvasiveCancer) : null);
			addColumn('histology.scoreInsituCancer', scored ? asPercent(bestStain.ScoreInsituCancer) : null);
			addColumn('histology.scoreLymphocytes', scored ? asPercent(bestStain.ScoreLymphocytes) : null);
			addColumn('histology.scoreNormal', scored ? asPercent(bestStain.ScoreNormal) : null);
			addColumn('histology.scoreStroma', scored ? asPercent(bestStain.ScoreStroma) : null);
			addColumn('histology.scoreFat', scored ? asPercent(bestStain.ScoreFat) : null);
			addColumn('histology.scoreComments', scored ? truncate(bestStain.comments, truncateAt) : null);
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('histology.name', asNoInfo('No histology information has been registered'));
			Main.hide('histology-details');
		}
		else
		{
			Main.hide('histology-info');
		}
	}
	
	
	var lysate = consentOk ? response.lysate : null;
	if (lysate && lysate.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(lysate.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < lysate.length; i++)
		{
			var lys = lysate[i];
			addColumn('lysate.name', makeLink('EXTRACT', lys));
			addColumn('lysate.registrationDate', formatDate(lys.registrationDate));
			addColumn('lysate.partitionDate', formatDate(lys.partitionDate));
			addColumn('lysate.usedQuantity', formatQuantity(lys.usedQuantity, 1000, ' mg'));
			addColumn('lysate.multiplePieces', lys.multiplePieces ? 'Yes' : 'No');
			addColumn('lysate.comment', truncate(lys.comment, truncateAt));
			
			var lysis = lys.lysisDate ? true : false;
			addColumn('lysate.lysisDate', lysis ? formatDate(lys.lysisDate) : 'No');
			addColumn('lysate.storageBox', lysis ? asBioPlateLocation(lys.bioWell) : null);
			addColumn('lysate.lysisProtocol', lysis ? makeLink('PROTOCOL', lys.lysisProtocol, truncateAt) : null);
			addColumn('lysate.remainingQuantity', lysis ? formatQuantity(lys.remainingQuantity, null, ' µg') : null);
			addColumn('lysate.originalQuantity', lysis ? formatQuantity(lys.originalQuantity, null, ' µg') : null);
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('lysate.name', asNoInfo('No lysate information has been registered'));
			Main.hide('lysate-details');
		}
		else
		{
			Main.hide('lysate-info');
		}
	}

	
	var rna = consentOk ? response.rna : null;
	if (rna && rna.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(rna.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < rna.length; i++)
		{
			var r = rna[i];
			addColumn('rna.name', makeLink('EXTRACT', r));
			addColumn('rna.flag', r.flag ? asFlagInfo(r.flag, 'flag.png') : null);
			addColumn('rna.registrationDate', formatDate(r.registrationDate));
			addColumn('rna.storageBox', asBioPlateLocation(r.bioWell));
			addColumn('rna.usedQuantity', formatQuantity(r.usedQuantity, null, ' µg'));
			addColumn('rna.extractionDate', formatDate(r.extractionDate));
			addColumn('rna.extractionProtocol', makeLink('PROTOCOL', r.extractionProtocol, truncateAt));
			addColumn('rna.remainingQuantity', formatQuantity(r.remainingQuantity, null, ' µg'));
			addColumn('rna.originalQuantity', formatQuantity(r.originalQuantity, null, ' µg'));
			addColumn('rna.ndConc', formatQuantity(r.ndConc, null, ' ng/µl'));
			addColumn('rna.comment', truncate(r.comment, truncateAt));
			
			var hasQc = r.nofQc ? true : false;
			addColumn('rna.qc', hasQc ? (r.qcDate ? formatDate(r.qcDate) : asNoInfo('Waiting for Caliper...')) : 'No');
			addColumn('rna.nofQc', hasQc ? r.nofQc : null);
			addColumn('rna.qcProtocol', hasQc ? makeLink('PROTOCOL', r.qcProtocol, truncateAt) : null);
			addColumn('rna.qcPlate', hasQc ? asBioPlateLocation(r.qcPlate)+asFileLink(r.qcPdf, 'pdffile.png') : null);
			addColumn('rna.qcRqs', hasQc && r.qcRqs ? formatNumber(r.qcRqs, null, 1) : null);
			addColumn('rna.qcRin', hasQc && r.qcRin ? formatNumber(r.qcRin, null, 1) : null);
			addColumn('rna.qcComment', hasQc ? truncate(r.qcComment, truncateAt) : null);
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('rna.name', asNoInfo('No RNA information has been registered'));
			Main.hide('rna-details');
		}
		else
		{
			Main.hide('rna-info');
		}
	}

	var dna = consentOk ? response.dna : null;
	if (dna && dna.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(dna.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < dna.length; i++)
		{
			var d = dna[i];
			addColumn('dna.name', makeLink('EXTRACT', d));
			addColumn('dna.registrationDate', formatDate(d.registrationDate));
			addColumn('dna.storageBox', asBioPlateLocation(d.bioWell));
			addColumn('dna.extractionDate', formatDate(d.extractionDate));
			addColumn('dna.extractionProtocol', makeLink('PROTOCOL', d.extractionProtocol, truncateAt));
			addColumn('dna.remainingQuantity', formatQuantity(d.remainingQuantity, null, ' µg'));
			addColumn('dna.originalQuantity', formatQuantity(d.originalQuantity, null, ' µg'));
			addColumn('dna.ndConc', formatQuantity(d.ndConc, null, ' ng/µl'));
			addColumn('dna.comment', truncate(d.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('dna.name', asNoInfo('No DNA information has been registered'));
			Main.hide('dna-details');
		}
		else
		{
			Main.hide('dna-info');
		}
	}

	var ft = consentOk ? response.flowThrough : null;
	if (ft && ft.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(ft.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < ft.length; i++)
		{
			var f = ft[i];
			addColumn('ft.name', makeLink('EXTRACT', f));
			addColumn('ft.registrationDate', formatDate(f.registrationDate));
			addColumn('ft.storageBox', asBioPlateLocation(f.bioWell));
			addColumn('ft.extractionDate', formatDate(f.extractionDate));
			addColumn('ft.extractionProtocol', makeLink('PROTOCOL', f.extractionProtocol, truncateAt));
			addColumn('ft.remainingQuantity', formatQuantity(f.remainingQuantity, null, ' µg'));
			addColumn('ft.originalQuantity', formatQuantity(f.originalQuantity, null, ' µg'));
			addColumn('ft.comment', truncate(f.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('ft.name', asNoInfo('No FlowThrough information has been registered'));
			Main.hide('ft-details');
		}
		else
		{
			Main.hide('ft-info');
		}
	}

	
	var mrna = consentOk ? response.mrna : null;
	if (mrna && mrna.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(mrna.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < mrna.length; i++)
		{
			var r = mrna[i];
			addColumn('mrna.name', makeLink('EXTRACT', r));
			addColumn('mrna.registrationDate', formatDate(r.registrationDate));
			addColumn('mrna.storageBox', asBioPlateLocation(r.bioWell)+asFileLink(r.platePdf, 'pdffile.png'));
			addColumn('mrna.result', (r.result && r.result != 'Successful') ? asFailInfo(r.result, 'error.png') : null);
			addColumn('mrna.cleanupDate', formatDate(r.cleanupDate));
			addColumn('mrna.usedQuantity', formatQuantity(r.usedQuantity, null, ' µg'));
			addColumn('mrna.comment', truncate(r.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('mrna.name', asNoInfo('No mRNA information has been registered'));
			Main.hide('mrna-details');
		}
		else
		{
			Main.hide('mrna-info');
		}
	}


	var cdna = consentOk ? response.cdna : null;
	if (cdna && cdna.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(cdna.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < cdna.length; i++)
		{
			var r = cdna[i];
			addColumn('cdna.name', makeLink('EXTRACT', r));
			addColumn('cdna.registrationDate', formatDate(r.registrationDate));
			addColumn('cdna.storageBox', asBioPlateLocation(r.bioWell));
			addColumn('cdna.result', (r.result && r.result != 'Successful') ? asFailInfo(r.result, 'error.png') : null);
			addColumn('cdna.synthesisDate', formatDate(r.synthesisDate));
			addColumn('cdna.comment', truncate(r.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('cdna.name', asNoInfo('No cDNA information has been registered'));
			Main.hide('cdna-details');
		}
		else
		{
			Main.hide('cdna-info');
		}
	}


	var lib = consentOk ? response.lib : null;
	if (lib && lib.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(lib.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < lib.length; i++)
		{
			var r = lib[i];
			addColumn('lib.name', makeLink('EXTRACT', r));
			addColumn('lib.registrationDate', formatDate(r.registrationDate));
			addColumn('lib.storageBox', asBioPlateLocation(r.bioWell));
			addColumn('lib.result', (r.result && r.result != 'Successful') ? asFailInfo(r.result, 'error.png') : null);
			addColumn('lib.cleanupDate', formatDate(r.cleanupDate));
			addColumn('lib.remainingQuantity', formatQuantity(r.remainingQuantity, 0.001, ' ng'));
			addColumn('lib.originalQuantity', formatQuantity(r.originalQuantity, 0.001, ' ng'));
			addColumn('lib.barcode.name', r.barcode.name);
			addColumn('lib.ca_size', formatQuantity(r.ca_size, null, ''));
			addColumn('lib.ca_molarity', formatQuantity(r.ca_molarity, null, ' nM'));
			addColumn('lib.qubitconc', formatQuantity(r.qubitconc, null, ' ng/µl'));
			addColumn('lib.comment', truncate(r.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('lib.name', asNoInfo('No library information has been registered'));
			Main.hide('lib-details');
		}
		else
		{
			Main.hide('lib-info');
		}
	}


	var pooledLib = consentOk ? response.pooledlib : null;
	if (pooledLib && pooledLib.length > 0)
	{
		var truncateAt = TRUNCATE_SIZE[Math.min(pooledLib.length-1, TRUNCATE_SIZE.length)];
		for (var i = 0; i < pooledLib.length; i++)
		{
			var r = pooledLib[i];
			addColumn('pooledlib.name', makeLink('EXTRACT', r));
			addColumn('pooledlib.registrationDate', formatDate(r.registrationDate));
			addColumn('pooledlib.poolDate', formatDate(r.poolDate));
			addColumn('pooledlib.remainingQuantity', formatQuantity(r.remainingQuantity, 0.001, ' ng'));
			addColumn('pooledlib.originalQuantity', formatQuantity(r.originalQuantity, 0.001, ' ng'));
			addColumn('pooledlib.poolMolarity', formatQuantity(r.poolMolarity, null, ' nM'));
			addColumn('pooledlib.poolConc', formatQuantity(r.poolConc, null, ' ng/µl'));
			addColumn('pooledlib.comment', truncate(r.comment, truncateAt));
		}
	}
	else
	{
		if (consentOk)
		{
			addColumn('pooledlib.name', asNoInfo('No pooled library information has been registered'));
			Main.hide('pooledlib-details');
		}
		else
		{
			Main.hide('pooledlib-info');
		}
	}
}

function caseSummary(caseName)
{
	var frm = document.forms['reggie'];
	if (!caseName)
	{
		caseName = frm.caseName.value;
		if (!caseName)
		{
			alert('Please enter a 7-digit case id');
			return;
		}
	}
	location.href = 'case_summary.jsp?ID=<%=ID%>&caseName='+encodeURIComponent(caseName)+'&pageType=<%=pageType%>';
}

function showConfidentialOnChange()
{
	var frm = document.forms['reggie'];
	if (frm.showConfidential.checked)
	{
		Main.removeClass(document.getElementById('all-info'), 'hide-confidential');
	}
	else
	{
		Main.addClass(document.getElementById('all-info'), 'hide-confidential');
	}
}

function goPrint()
{
	var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.<br>';
	printNote += ' You may have to <i>scale down</i> to fit everything on the width of the page.';
	openPrintWindow('<%=ID%>', 'all-content', 'Case summary - ' + escape(caseName), 'portrait', printNote, '../', 'case_summary.css');
}

function toggleDetails(event)
{
	var sectionId = event.currentTarget.sectionId;
	var details = document.getElementById(sectionId+'-details');
	// If the details section is 'forcibly' hidden (eg. no items of that type), ignore this call
	if (details.style.display == 'none') return;
	
	// Add 'hide-details' class to main <div section-info> if it is visible
	var section = document.getElementById(sectionId+'-info');
	var isVisible = section.className.indexOf('hide-details') == -1;
	Main.addOrRemoveClass(section, 'hide-details', isVisible);

	// Save to BASE setting
	var url = '../CaseSummary.servlet?ID=<%=ID%>&cmd=SetSectionVisibility';
	url += '&section='+sectionId+'&hidden='+(isVisible ? 1 : 0);
	var request = Ajax.getXmlHttpRequest();
	request.open("POST", url, false); 
	request.send(null);
	
	if (debug) Main.debug(request.responseText);
}

function initSections(sections)
{
	for (var s = 0; s < sections.length; s++)
	{
		var section = sections[s];

		var details = document.getElementById(section.id+'-details');
		// If the details section is 'forcibly' hidden (eg. no items of that type), ignore this call
		if (details.style.display != 'none')
		{
			var headerDiv = document.getElementById(section.id+'-header');
			if (headerDiv)
			{
				Main.addClass(headerDiv, 'link');
				headerDiv.title = 'Hide/show details';
				headerDiv.sectionId = section.id;
				headerDiv.addEventListener('click', toggleDetails, false);
			}
			
			var sectionDiv = document.getElementById(section.id+'-info');
			Main.addOrRemoveClass(sectionDiv, 'hide-details', section.hiddenDetails);
		}
	}
}

</script>
<style>

</style>
</base:head>

<base:body onload="init()">
	<div id="all-content">
	<%
	if (fullPage)
	{
		%>
		<p:path><p:pathelement id="path-reggie" clazz="noprint"
			title="Reggie" href="<%="../index.jsp?ID="+ID%>"
			/><p:pathelement id="path-case-summary" title="<%="Case summary - " + HTML.encodeTags(caseName)%>" 
			/></p:path>
		<%
	}
	else if (popup)
	{
		%>
		<h1  id="path-case-summary-popup">Case summary - <%= HTML.encodeTags(caseName)%></h1>
		<%
	}
	%>
	<div class="content">
	<form name="reggie" onsubmit="return false;">
	<%
	if (fullPage || popup)
	{
		%>
		<div class="filled noprint" id="toolbar">
			<table>
			<tr>
				<th style="padding: 0.5em 0.75em 0.5em 0.75em;">Find another case</th>
				<td><input type="text" class="text" style="width: 25em;"
					name="caseName" title="Please enter a 7-digit case id"
					onkeypress="if (event.keyCode==13 && this.value) caseSummary()"></td>
				<td style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0; "><base:icon image="<%=home+"/images/gonext.png"%>" onclick="caseSummary()"></base:icon></td>
				<%
				if (isAdmin || isPatientCurator)
				{
					%>
					<th style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0;">
						<label for="showConfidential">Show confidential information</label>
						<input type="checkbox" id="showConfidential" name="showConfidential" onchange="showConfidentialOnChange()">
					</th>
					<%
				}
				%>
				<th style="padding-left: 0.5em; padding-right: 0.5em; border-right: 1px dotted #A0A0A0;">
					<span id="printButton" class="link" onclick="goPrint()"><img src="../images/print.png" style="padding-right: 0.5em;">Print version&hellip;</span>
				</th>
				<th style="width: 90%;"></th>
			</tr>
			</table>
		</div>
		<%
	}
	%>
	<div class="hide-confidential" id="all-info" style="display: none;">
		<div id="left-column">
			<div>
				<%
				if (sc.getActiveProjectId() == 0)
				{
					%>
					<div class="messagecontainer note" style="margin-bottom: 20px; font-weight: bold; color: #cc0000;">
						No project has been selected. You may not be able to see all registered information.
					</div>
					<%
				}
				%>
				<div class="info-section" id="case-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="case.name">
							<th id="case-header">Case</th>
						</tr>
					</thead>
					<tbody id="case-details" class="info-details">
						<tr id="case.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="case.site">
							<th>Site</th>
						</tr>
						<tr id="case.laterality" class="dynamic-column">
							<th>Laterality</th>
						</tr>
						<tr id="case.consent">
							<th>Consent</th>
						</tr>
						<tr id="case.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="patient-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="patient.name">
							<th id="patient-header">Patient</th>
						</tr>
					</thead>
					<tbody id="patient-details" class="info-details">
						<tr id="patient.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="patient.personalNumber" class="confidential">
							<th>Personal number</th>
						</tr>
						<tr id="patient.allFirstNames" class="confidential">
							<th>All first names</th>
						</tr>
						<tr id="patient.familyName" class="confidential">
							<th>Family name</th>
						</tr>
						<tr id="patient.gender">
							<th>Gender</th>
						</tr>
						<tr id="patient.allCases" class="dynamic-column">
							<th>All cases</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="blood-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="blood.name">
							<th id="blood-header">Blood</th>
						</tr>
					</thead>
					<tbody id="blood-details" class="info-details">
						<tr id="blood.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="blood.consent">
							<th>Consent</th>
						</tr>
						<tr id="blood.bloodSample">
							<th>Blood sample</th>
						</tr>
						<tr id="blood.samplingDate">
							<th>Sampling date</th>
						</tr>
						<tr id="blood.freezerDate">
							<th>Freezer date</th>
						</tr>
						<tr id="blood.serum">
							<th>Serum</th>
						</tr>
						<tr id="blood.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="specimen-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="specimen.name">
							<th id="specimen-header">Specimen</th>
						</tr>
					</thead>
					<tbody id="specimen-details" class="info-details">
						<tr id="specimen.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="specimen.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="specimen.laterality">
							<th>Laterality</th>
						</tr>
						<tr id="specimen.samplingDate">
							<th>Sampling date</th>
						</tr>
						<tr id="specimen.rnaLaterDate">
							<th>RNA later date</th>
						</tr>
						<tr id="specimen.pad" class="confidential">
							<th>PAD</th>
						</tr>
						<tr id="specimen.biopsyType">
							<th>Biopsy type</th>
						</tr>
						<tr id="specimen.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="specimen.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="specimen.nofPieces">
							<th>No. pieces</th>
						</tr>
						<tr id="specimen.partitionComment">
							<th>Partition comment</th>
						</tr>
						<tr id="specimen.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="nospecimen-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="nospecimen.name">
							<th id="nospecimen-header">NoSpecimen</th>
						</tr>
					</thead>
					<tbody id="nospecimen-details" class="info-details">
						<tr id="nospecimen.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="nospecimen.laterality">
							<th>Laterality</th>
						</tr>
						<tr id="nospecimen.samplingDate">
							<th>Sampling date</th>
						</tr>
						<tr id="nospecimen.pad" class="confidential">
							<th>PAD</th>
						</tr>
						<tr id="nospecimen.reasonIfNoSpecimen" class="comment">
							<th>Reason</th>
						</tr>
						<tr id="nospecimen.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="histology-info">
					<div>
					<table class="info-table">
					<thead>
						<tr id="histology.name">
							<th id="histology-header">Histology</th>
						</tr>
					</thead>
					<tbody id="histology-details" class="info-details">
						<tr id="histology.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="histology.storageBox" class="dynamic-column">
							<th>Storage box</th>
						</tr>
						<tr id="histology.partitionDate">
							<th>Partition date</th>
						</tr>
						<tr id="histology.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="histology.embedded" class="subtitle">
							<th>Embedded</th>
						</tr>
						<tr id="histology.paraffinBlock" class="dynamic-column">
							<th>Paraffin block</th>
						</tr>
						<tr id="histology.embedProtocol" class="dynamic-column">
							<th>Protocol</th>
						</tr>
						<tr id="histology.stained" class="subtitle">
							<th>Stained</th>
						</tr>
						<tr id="histology.nofSlides" class="dynamic-column">
							<th>No. slides</th>
						</tr>
						<tr id="histology.heGlass" class="dynamic-column">
							<th>Best slide</th>
						</tr>
						<tr id="histology.stainProtocol" class="dynamic-column">
							<th>Protocol</th>
						</tr>
						<tr id="histology.scored" class="subtitle">
							<th>Scored</th>
						</tr>
						<tr id="histology.scoreInvasiveCancer" class="dynamic-column">
							<th>Invasive cancer</th>
						</tr>
						<tr id="histology.scoreInsituCancer" class="dynamic-column">
							<th>Insitu cancer</th>
						</tr>
						<tr id="histology.scoreLymphocytes" class="dynamic-column">
							<th>Lymphocytes</th>
						</tr>
						<tr id="histology.scoreNormal" class="dynamic-column">
							<th>Normal</th>
						</tr>
						<tr id="histology.scoreStroma" class="dynamic-column">
							<th>Stroma</th>
						</tr>
						<tr id="histology.scoreFat" class="dynamic-column">
							<th>Fat</th>
						</tr>
						<tr id="histology.scoreComments" class="comment dynamic-column">
							<th>Comments</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
			
			</div>
		</div>
		<div id="right-column">
			<div>
				<div class="info-section" id="lysate-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="lysate.name">
							<th id="lysate-header">Lysate</th>
						</tr>
					</thead>
					<tbody id="lysate-details" class="info-details">
						<tr id="lysate.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="lysate.partitionDate">
							<th>Partition date</th>
						</tr>
						<tr id="lysate.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="lysate.multiplePieces">
							<th>Multiple pieces</th>
						</tr>
						<tr id="lysate.lysisDate" class="subtitle">
							<th>Lysis date</th>
						</tr>
						<tr id="lysate.storageBox" class="dynamic-column">
							<th>Storage box</th>
						</tr>
						<tr id="lysate.lysisProtocol" class="dynamic-column">
							<th>Protocol</th>
						</tr>
						<tr id="lysate.remainingQuantity" class="dynamic-column">
							<th>Remaining quantity</th>
						</tr>
						<tr id="lysate.originalQuantity" class="dynamic-column">
							<th>Original quantity</th>
						</tr>
						<tr id="lysate.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
					
				<div class="info-section" id="rna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="rna.name">
							<th id="rna-header">RNA</th>
						</tr>
					</thead>
					<tbody id="rna-details" class="info-details">
						<tr id="rna.flag" class="dynamic-column">
							<th>Flag</th>
						</tr>
						<tr id="rna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="rna.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="rna.extractionDate">
							<th>Extraction date</th>
						</tr>
						<tr id="rna.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="rna.extractionProtocol">
							<th>Protocol</th>
						</tr>
						<tr id="rna.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="rna.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="rna.ndConc">
							<th>ND Conc.</th>
						</tr>
						<tr id="rna.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
						<tr id="rna.qc" class="subtitle">
							<th>QC (last)</th>
						</tr>
						<tr id="rna.nofQc" class="dynamic-column">
							<th>No. QC</th>
						</tr>
						<tr id="rna.qcProtocol" class="dynamic-column">
							<th>Protocol</th>
						</tr>
						<tr id="rna.qcPlate" class="dynamic-column">
							<th>Plate</th>
						</tr>
						<tr id="rna.qcRqs" class="dynamic-column">
							<th>RQS</th>
						</tr>
						<tr id="rna.qcRin" class="dynamic-column">
							<th>RIN</th>
						</tr>
						<tr id="rna.qcComment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="dna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="dna.name">
							<th id="dna-header">DNA</th>
						</tr>
					</thead>
					<tbody id="dna-details" class="info-details">
						<tr id="dna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="dna.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="dna.extractionDate">
							<th>Extraction date</th>
						</tr>
						<tr id="dna.extractionProtocol">
							<th>Protocol</th>
						</tr>
						<tr id="dna.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="dna.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="dna.ndConc">
							<th>ND Conc.</th>
						</tr>
						<tr id="dna.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>

				<div class="info-section" id="ft-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="ft.name">
							<th id="ft-header">FlowThrough</th>
						</tr>
					</thead>
					<tbody id="ft-details" class="info-details">
						<tr id="ft.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="ft.storageBox">
							<th>Storage box</th>
						</tr>
						<tr id="ft.extractionDate">
							<th>Extraction date</th>
						</tr>
						<tr id="ft.extractionProtocol">
							<th>Protocol</th>
						</tr>
						<tr id="ft.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="ft.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="ft.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="mrna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="mrna.name">
							<th id="mrna-header">mRNA</th>
						</tr>
					</thead>
					<tbody id="mrna-details" class="info-details">
						<tr id="mrna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="mrna.storageBox">
							<th>Work plate</th>
						</tr>
						<tr id="mrna.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="mrna.cleanupDate">
							<th>Cleanup date</th>
						</tr>
						<tr id="mrna.usedQuantity">
							<th>Used quantity</th>
						</tr>
						<tr id="mrna.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="cdna-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="cdna.name">
							<th id="cdna-header">cDNA</th>
						</tr>
					</thead>
					<tbody id="cdna-details" class="info-details">
						<tr id="cdna.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="cdna.storageBox">
							<th>Work plate</th>
						</tr>
						<tr id="cdna.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="cdna.synthesisDate">
							<th>Synthesis date</th>
						</tr>
						<tr id="cdna.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="lib-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="lib.name">
							<th id="lib-header">Library</th>
						</tr>
					</thead>
					<tbody id="lib-details" class="info-details">
						<tr id="lib.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="lib.storageBox">
							<th>Library plate</th>
						</tr>
						<tr id="lib.result" class="dynamic-column">
							<th>Plate result</th>
						</tr>
						<tr id="lib.cleanupDate">
							<th>Cleanup date</th>
						</tr>
						<tr id="lib.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="lib.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="lib.barcode.name">
							<th>Tag</th>
						</tr>
						<tr id="lib.ca_size">
							<th>CA_Size</th>
						</tr>
						<tr id="lib.ca_molarity">
							<th>CA_Molarity</th>
						</tr>
						<tr id="lib.qubitconc">
							<th>QubitConc</th>
						</tr>
						<tr id="lib.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
				<div class="info-section" id="pooledlib-info">
					<div>
					<table class="info-table dynamic-columns">
					<thead>
						<tr id="pooledlib.name">
							<th id="pooledlib-header">Pooled Library</th>
						</tr>
					</thead>
					<tbody id="pooledlib-details" class="info-details">
						<tr id="pooledlib.registrationDate">
							<th>Registration date</th>
						</tr>
						<tr id="pooledlib.poolDate">
							<th>Pool date</th>
						</tr>
						<tr id="pooledlib.remainingQuantity">
							<th>Remaining quantity</th>
						</tr>
						<tr id="pooledlib.originalQuantity">
							<th>Original quantity</th>
						</tr>
						<tr id="pooledlib.poolMolarity">
							<th>PoolMolarity</th>
						</tr>
						<tr id="pooledlib.poolConc">
							<th>PoolConc</th>
						</tr>
						<tr id="pooledlib.comment" class="comment dynamic-column">
							<th>Comment</th>
						</tr>
					</tbody>
					</table>
					</div>
				</div>
				
			</div>
		</div>
	</div>
	</form>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	</div>
	</div>
	<%
	if (popup)
	{
		%>
		<base:buttongroup subclass="dialogbuttons topborder" id="dialogbuttons">
			<base:button onclick="window.close()" title="Close" />
		</base:buttongroup>
		<%
	}
	%>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>