<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.DbControl"	
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	
<script language="JavaScript">
var caseIsValid = false;
var arrivalDateIsValid = true;
var nofTubesIsValid = false;
var lateralityIsValid = true;
var boxesAreValid = null;
var wellsAreValidValid = null;
var specimenTypeIsValid = false;
var samplingDateIsValid = true;
var rnaLaterDateIsValid = true;
var biopsyTypeIsValid = true;
var debug = false;
var currentStep = 1;
var usedBox = '';
var restartTimer;

var caseInfo = null;
var boxInfo = null;

function init()
{
	var frm = document.forms['reggie'];
	frm.caseName.focus();
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	else if (currentStep == 2)
	{
		if (step2IsValid()) gotoStep3();
	}
}

function step2IsValid()
{
	var frm = document.forms['reggie'];	
	if (!nofTubesIsValid) 
	{
		frm.nofTubes.focus();
		return false;
	}
	if (!arrivalDateIsValid)
	{
		frm.arrivalDate.focus();
		return false;
	}
	if (!samplingDateIsValid)
	{
		frm.samplingDate.focus();
		return false;
	}
	if (!rnaLaterDateIsValid)
	{
		frm.rnaLaterDate.focus();
		return false;
	}
	if (!lateralityIsValid) return false;
	if (!biopsyTypeIsValid) return false;
	return true;
}

function gotoStep2()
{
	var frm = document.forms['reggie'];
	var caseName = frm.caseName.value.toUpperCase();
	if (caseName == '')
	{
		setInputStatus('case', 'Missing', 'invalid');
		return;
	}
	if (!isValidCaseName(caseName, true))  // Allow 'C' suffix to be used
	{
		setInputStatus('case', 'Only 7-digits name + optional \'C\' is allowed.', 'invalid');
		frm.caseName.focus();
		return;
	}
	frm.caseName.value = caseName;
	setInputStatus('case', '', 'valid');
	
	getCaseInfo();
	
	frm.caseName.disabled = true;
	if (caseInfo != null)
	{
		Main.show('gocancel');
		Main.show('caseSection');
	}
	
	var currentTime = new Date();
	var currentYear = currentTime.getFullYear().toString();
	var currentMonth = (currentTime.getMonth()+1).toString();
	currentMonth = currentMonth.length < 2 ? '0'+currentMonth : currentMonth;
	var currentDate = currentTime.getDate().toString();
	currentDate = currentDate.length < 2 ? '0'+currentDate : currentDate;
	
	var dateString = currentYear + currentMonth + currentDate;
	
	frm.arrivalDate.value = dateString;
		
	frm.nofTubes.focus();
	frm.nofTubes.setSelectionRange(0,1);
	
	// Select 'Laterality' if we have that information since before
	if (caseInfo.laterality)
	{
		Forms.checkRadio(frm.laterality, caseInfo.laterality);
		lateralityOnChange();
		
		if (caseInfo.laterality == 'LEFT') Main.hide('lateralityRight');
		if (caseInfo.laterality == 'RIGHT') Main.hide('lateralityLeft');
		Main.hide('lateralityUnknown');
		document.getElementById('lateralityFromCase').innerHTML = '(From existing case: ' + caseInfo.name + ')';
		Main.show('lateralityFromCase');
	}
	
	
	// Select 'SpecimenCoreBiopsy' if case name has 'C' suffix
	var caseName = frm.caseName.value;
	if (caseName.length > 7 && caseName.substring(7, 8) == 'C')
	{
		Forms.selectListOption(frm.biopsyType, 'SpecimenCoreBiopsy');
		biopsyTypeOnClick();
	}

	currentStep = 2;		
}

function gotoStep3()
{
	var frm = document.forms['reggie'];
	var inputTubeHtml = '';
	var nofTubes = parseInt(frm.nofTubes.value);
	boxInfo = new Array(nofTubes);
	
	var freeWells = findStoragePositions(nofTubes);
	
	frm.arrivalDate.disabled = true;
	frm.nofTubes.disabled = true;
	for (var i=0;i<frm.laterality.length;i++)
	{
		frm.laterality[i].disabled = true;
	}
	frm.rnaLaterDate.disabled = true;
	frm.samplingDate.disabled = true;
	frm.rnaLaterTime.disabled = true;
	frm.samplingTime.disabled = true;
	frm.otherPathNote.disabled = true;
	frm.specimenType.disabled = true;
	frm.biopsyType.disabled = true;
	
	boxesAreValid = new Array(nofTubes);
	wellsAreValid = new Array(nofTubes);
	
	for (var i=0;i<nofTubes;i++)
	{
		var specimen = null;
		
		var freeWell = freeWells.length > i ? freeWells[i] : null;
		var boxValue = freeWell == null ? '' : freeWell.bioPlate.name;
		var rowValue = freeWell == null ? '' : WELL_ALPHA[freeWell.row];
		var columnValue = freeWell == null ? '' : freeWell.column+1;
		boxInfo[i] = freeWell == null ? '' : freeWell.bioPlate.id;
		boxesAreValid[i] = freeWell != null;
		wellsAreValid[i] = freeWell != null;
		var spWeightValue = '';
		var hisWeightValue = '';
		var allPrepWeightValue = '';
		
		inputTubeHtml += '<tr>';
		inputTubeHtml += '<td class="prompt">Specimen Tube '+caseInfo.name+'.'+(i+caseInfo.specimenFirstIndex)+'</td>';
		inputTubeHtml += '</tr>';

		var box = 'box'+i;	
		var row = 'row'+i;
		var column = 'column'+i;
		var operatorComment = 'operatorComment'+i;
		inputTubeHtml += '<tr>';
		inputTubeHtml += '<td class="subprompt">Box</td>';
		inputTubeHtml += '<td class="input">';
		inputTubeHtml += '<input type="text" onkeypress="focusOnEnter(event, \''+row+'\')" name='+box+' value="' + boxValue + '" size="12" maxlength="12" onKeyUp="boxOnKeyUp('+i+')" onBlur="boxOnChange('+i+')"></td>';
		inputTubeHtml += '<td class="status ' + (boxesAreValid[i] ? 'valid' : '') + '" id="'+box+'.status"></td>';
		inputTubeHtml += '<td class="help"><span id="'+box+'.message" class="message" style="display: none;"></span>Box-number where the specimen tube is located in.</td>';		
		inputTubeHtml += '</tr>';				
		
		inputTubeHtml += '<tr>';
		inputTubeHtml += '<td class="subprompt">Row</td>';
		inputTubeHtml += '<td class="input"><input style="text-transform:uppercase;" type="text"  onkeypress="focusOnEnter(event, \''+column+'\')" name='+row+' value="' + rowValue + '" size="3" maxlength="2" ';
		inputTubeHtml += ' onBlur="wellOnChange('+i+')">';
		inputTubeHtml += '&nbsp;Column<input type="text" onkeypress="focusOnEnter(event, \''+operatorComment+'\');  return true || Numbers.integerOnly(event);" name='+column+' value="'+ columnValue + '" size="3" maxlength="3" ';
		inputTubeHtml += ' onBlur="wellOnChange('+i+')">';
		inputTubeHtml += '</td>';
		inputTubeHtml += '<td class="status ' + (wellsAreValid[i] ? 'valid' : '') + '" id="rowColumn'+i+'.status"></td>';
		inputTubeHtml += '<td class="help"><span id="rowColumn'+i+'.message" class="message" style="display: none;"></span></td>';		
		inputTubeHtml += '</tr>';

		var doOnTab = i==(nofTubes-1) ? 'doOnTab(event, goCreate)' : '';
		inputTubeHtml += '<tr>';
		inputTubeHtml += '<td class="subprompt">Operator delivery comment</td>';
		inputTubeHtml += '<td class="input"><textarea rows="3" cols="30" name='+operatorComment+' value="" onkeypress="'+doOnTab+'"></textarea></td>';
		inputTubeHtml += '<td class="status" id="'+operatorComment+'.status"></td>';
		inputTubeHtml += '<td class="help"><span id="'+operatorComment+'.message" class="message" style="display: none;"></span>Operator delivery comment</td>';		
		inputTubeHtml += '</tr>';
	}
	setInnerHTML('tubeInputs', inputTubeHtml);	
	currentStep = 3;
	Main.show('tubeSection');	
	Main.hide('gonext');	

	Main.show('gocreate');	

	var textLength = frm.box0.value.length;
	frm.box0.focus();
	frm.box0.setSelectionRange(textLength,textLength);
	
}

function findStoragePositions(nofTubes)
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Lysate extracts...');
		var url = '../SpecimenTubeRegistration.servlet?ID=<%=ID%>&cmd=FindStoragePositions';	
		url += '&nofTubes='+nofTubes;
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.wells;
}


function samplingDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	var todaysDate = new Date();
	samplingDateIsValid = false;
	setInputStatus('samplingDate', '', '');
	
	var samplingDate = frm.samplingDate.value;
	var samplingTime = frm.samplingTime.value;
	
	if (samplingDate != '' || samplingTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		samplingDate = autoFillDate(samplingDate);
		frm.samplingDate.value = samplingDate;

		samplingTime = autoFillTime(samplingTime);
		frm.samplingTime.value = samplingTime;
		
		if (!Dates.isDate(samplingDate, 'yyyyMMdd'))
		{
			setInputStatus('samplingDate', 'Not a valid date', 'invalid');
			return;
		}		
		if (todaysDate < new Date(samplingDate.substring(0,4),new Number(samplingDate.substring(4,6)-1), samplingDate.substring(6)) )
		{
			setInputStatus('samplingDate', 'Future date is not valid', 'invalid');
			return;
		}
		if (frm.rnaLaterDate.value == '') frm.rnaLaterDate.value = samplingDate;
		
		if (!Dates.isDate(samplingDate + ' ' + samplingTime, 'yyyyMMdd HHmm'))
		{
			if (samplingDate != '') setInputStatus('samplingDate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
			return;
		}
		setInputStatus('samplingDate', '', 'valid');
	}
	samplingDateIsValid = true;
	rnaLaterDateTimeOnChange();
}

function boxOnKeyUp(tubeIndex)
{
	var frm = document.forms['reggie'];
	var boxName = 'box'+tubeIndex;
	var boxValue = frm.elements[boxName].value;
	if (boxValue.length>0 && boxValue.substring(0,2) != 'Sp')
	{
		boxValue = 'Sp'+boxValue;
	}
	frm.elements[boxName].value = boxValue;
}

function boxOnChange(tubeIndex)
{
	var frm = document.forms['reggie'];
	var boxName = 'box'+tubeIndex;
	var boxValue = frm.elements[boxName].value;	
	
	boxValue = boxValue.substring(2);	
	while (boxValue.length > 0 && boxValue.length < 3)
	{		
		boxValue = '0'+boxValue;
	}
	if (boxValue.length > 0)
	{
		boxValue = 'Sp'+boxValue;
	}	
	frm.elements[boxName].value = boxValue;
		
	var request = Ajax.getXmlHttpRequest();
	var url = '../SpecimenTubeRegistration.servlet?ID=<%=ID%>&cmd=GetBoxInfo';
	url += '&boxName=' + boxValue;
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		boxesAreValid[tubeIndex] = false;		
		setFatalError(response.message);
		return false;
	}	
	if (!response.boxInfo)
	{
		boxesAreValid[tubeIndex] = false;
		setInputStatus(boxName, response.message, 'invalid');
		return false;
	}		
	else 
	{
		setInputStatus('rowColumn'+tubeIndex,'Row[A-'+response.rows+'], Columns[1-'+response.columns+']','');
		boxesAreValid[tubeIndex] = true;
		boxInfo[tubeIndex] = response.boxInfo;	
		
		if (tubeIndex==0)
		{
			usedBox = boxValue;			
		}
		
		if (usedBox != boxValue)
		{			
			setInputStatus(boxName, 'More then one box is used','warning');
			return;
		}
		setInputStatus('rowColumn'+tubeIndex,'Row[A-'+response.rows+'], Columns[1-'+response.columns+']','');
		if (response.message && "Warning:" == response.message.substring(0,8))
		{
			setInputStatus(boxName, response.message.substring(8), 'warning');
		}
		else
		{
			setInputStatus(boxName, '', 'valid');
		}
	}		
}

function wellOnChange(tubeIndex)
{
	var frm = document.forms['reggie'];
	var boxName = 'box'+tubeIndex;
	var rowName = 'row'+tubeIndex;
	var columnName = 'column'+tubeIndex;
	var rowValue = frm.elements[rowName].value;
	var columnValue = frm.elements[columnName].value
	var boxValue = frm.elements[boxName].value;	
	var nofTubes = frm.nofTubes.value;
	
	wellsAreValid[tubeIndex] = false;
	
	if (boxValue != '' && 
			(rowValue == '' || columnValue == ''))
	{
		setInputStatus('rowColumn'+tubeIndex, 'Row or column cannot be empty when the box is specified.', 'invalid');
		return false;
	}
	
	if (boxInfo[tubeIndex] == null)
	{
		boxOnChange(tubeIndex);
		if (boxInfo[tubeIndex] == null) return;
	}
	
	var request = Ajax.getXmlHttpRequest();
	var url = '../SpecimenTubeRegistration.servlet?ID=<%=ID%>&cmd=ValidateWell';
	url += '&boxId=' + boxInfo[tubeIndex];	
	url += '&row=' + rowValue;
	url += '&column=' + columnValue;
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setInputStatus('rowColumn'+tubeIndex, response.message, 'invalid');
		return false;
	}
	if (response.message)
	{
		if (response.message.length>8 && response.message.substring(0,8) == "Warning:")
		{
			setInputStatus('rowColumn'+tubeIndex, response.message.substring(8), 'warning');
		}
		else
		{
			setInputStatus('rowColumn'+tubeIndex, response.message, 'invalid')
			return false;
		}		
	}
	for (var i=0;i<nofTubes;i++)
	{		
		if (i != tubeIndex && frm.elements['box'+i].value == boxValue)
		{
			if (rowValue == frm.elements['row'+i].value && 
					columnValue == frm.elements['column'+i].value)
			{
				setInputStatus('rowColumn'+tubeIndex, 'The row and column are already used once in this wizard','invalid');				
				return false;
			}
		}
	}
	wellsAreValid[tubeIndex] = true;
	setInputStatus('rowColumn'+tubeIndex, '', 'valid');
}

function rnaLaterDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	var todaysDate = new Date();
	rnaLaterDateIsValid = false;
	setInputStatus('rnaLaterDate', '', '');
	
	var rnaLaterDate = frm.rnaLaterDate.value;
	var rnaLaterTime = frm.rnaLaterTime.value;
	var rnaLaterTimestamp;
	
	if (rnaLaterDate != '' || rnaLaterTime != '')
	{
		// Auto-fill the date if it's not given in yyyyMMdd
		rnaLaterDate = autoFillDate(rnaLaterDate);
		frm.rnaLaterDate.value = rnaLaterDate;

		rnaLaterTime = autoFillTime(rnaLaterTime);
		frm.rnaLaterTime.value = rnaLaterTime;
		
		if (!Dates.isDate(rnaLaterDate, 'yyyyMMdd'))
		{
			setInputStatus('rnaLaterDate', 'Not a valid date', 'invalid');
			return;
		}
		if (todaysDate < new Date(rnaLaterDate.substring(0,4),new Number(rnaLaterDate.substring(4,6)-1), rnaLaterDate.substring(6)) )
		{
			setInputStatus('rnaLaterDate', 'Future date is not valid', 'invalid');
			return;
		}
		rnaLaterTimestamp = Dates.parseString(rnaLaterDate + ' ' + rnaLaterTime, 'yyyyMMdd HHmm');
		if (rnaLaterTimestamp == null)
		{
			if (rnaLaterDate != '') setInputStatus('rnaLaterDate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
			return;
		}
		if (samplingDateIsValid && rnaLaterTimestamp)
		{
			var samplingTimestamp = Dates.parseString(frm.samplingDate.value + ' ' + frm.samplingTime.value, 'yyyyMMdd Hmm');			
			if (samplingTimestamp)
			{
				if (rnaLaterTimestamp.getDate() != samplingTimestamp.getDate())
				{
					setInputStatus('rnaLaterDate', 'Sampling and RNA later dates are different', 'invalid');
					return;
				}
				if (rnaLaterTimestamp.getTime() < samplingTimestamp.getTime())
				{
					setInputStatus('rnaLaterDate', 'RNA later time must be later than Sampling time','invalid');
					return;
				}
			}
			
		}
		setInputStatus('rnaLaterDate', '', 'valid');
	}
		
	rnaLaterDateIsValid = true;
}

function arrivalDateOnBlur()
{
	var frm = document.forms['reggie'];
	var arrivalDate = frm.arrivalDate.value;
	var todaysDate = new Date();
	arrivalDateIsValid = false;

	setInputStatus('arrivalDate', '', '');

	if (arrivalDate != '')
	{
		arrivalDate = autoFillDate(arrivalDate);
		frm.arrivalDate.value = arrivalDate;

		if (!Dates.isDate(arrivalDate, 'yyyyMMdd'))
		{
			setInputStatus('arrivalDate', 'Not a valid date', 'invalid');
			return;
		}
		if (todaysDate < new Date(arrivalDate.substring(0,4), new Number(arrivalDate.substring(4,6))-1, arrivalDate.substring(6)))
		{
			setInputStatus('arrivalDate', 'Future dates are not valid','invalid');
			return;	
		}
		setInputStatus('arrivalDate', '', 'valid');
	}
	else
	{
		setInputStatus('arrivalDate', 'Missing', 'warning');
	}	
	arrivalDateIsValid = true;
}

function nofTubesOnChange()
{
	var frm = document.forms['reggie'];
	var nofTubes = frm.nofTubes.value;

	if (nofTubes == '')
	{
		setInputStatus('nofTubes', 'Missing', 'invalid');
		return;
	}
	if (nofTubes < '1')
	{
		setInputStatus('nofTubes', 'Must be at least 1', 'invalid');
		return;		
	}
	setInputStatus('nofTubes','', 'valid');
	nofTubesIsValid = true; 
}


function lateralityOnChange()
{	
	lateralityIsValid = false;
	
	// Check selected laterality against specimen tubes
	var frm = document.forms['reggie'];
	var selectedLaterality = Forms.getCheckedRadio(frm.laterality);
	
	// No laterality/case selected
	if (selectedLaterality == null) 
	{
		setInputStatus('laterality', 'Not selected', 'invalid');
		return;
	}
	
	lateralityIsValid = true;

	if (caseInfo.laterality && caseInfo.laterality != selectedLaterality.value)
	{
		setInputStatus('laterality', 'Not same laterality as existing case/specimen', 'warning');	
		return;
	}
	
	setInputStatus('laterality', '', 'valid');
}

function specimenTypeOnClick()
{
	var frm = document.forms['reggie'];
	var selectedSpecimenType = frm.specimenType.value;
	
	specimenTypeIsValid = true;
	var specimenType = null;
	if (selectedSpecimenType != "")
	{
		specimenType = selectedSpecimenType;
	}
	setInputStatus('specimenType', '', 'valid');
}

function biopsyTypeOnClick()
{
	var frm = document.forms['reggie'];
	var selectedBiopsyType = frm.biopsyType.value;
	biopsyTypeIsValid = false;
	
	// Check 'SpecimenCoreBiopsy' if case name has 'C' suffix
	var caseName = frm.caseName.value;
	if (caseName.length > 7 && caseName.substring(7, 8) == 'C' && selectedBiopsyType != 'SpecimenCoreBiopsy')
	{
		setInputStatus('biopsyType', 'Case name with \'C\' suffix is always SpecimenCoreBiopsy', 'invalid');
		return;
	}
	
	biopsyTypeIsValid = true;
	setInputStatus('biopsyType', '', 'valid');
}

function step3IsValid()
{	
	var step3IsValid = false;
	var i=0;
	var bioWellsAreValid = true;
	while (i<boxesAreValid.length && bioWellsAreValid)
	{
		if (!boxesAreValid[i] || !wellsAreValid[i])
		{
			bioWellsAreValid = false;
		}
		i++;
	}
	step3IsValid = bioWellsAreValid;	
	return step3IsValid;
}

function goCreate()
{
	if (!step3IsValid()) return;

	Main.hide('gocancel');
	Main.hide('gocreate');
	Main.hide('goupdate');
	var frm = document.forms['reggie'];
	
	caseInfo.laterality = Forms.getCheckedRadio(frm.laterality).value;
	caseInfo.samplingDate = Main.trimString(frm.samplingDate.value + ' ' + frm.samplingTime.value);
	caseInfo.rnaLaterDate = Main.trimString(frm.rnaLaterDate.value + ' ' + frm.rnaLaterTime.value);
	caseInfo.otherPathNote = frm.otherPathNote.value;
	caseInfo.arrivalDate = Main.trimString(frm.arrivalDate.value);
	
	var nofTubes = frm.nofTubes.value;
	caseInfo.specimen = new Array(nofTubes);
	for (var i=0; i<nofTubes; i++)
	{
		var specimenTube = new Object();
		specimenTube.name = caseInfo.name+'.'+(i+caseInfo.specimenFirstIndex);

		frm.elements['box'+i].disabled = true;
		frm.elements['row'+i].disabled = true;
		frm.elements['column'+i].disabled = true;
		frm.elements['operatorComment'+i].disabled = true;
		
		if (boxInfo[i] != '') specimenTube.boxId = boxInfo[i];
		if (frm.elements['row'+i].value != '') specimenTube.row = frm.elements['row'+i].value;
		if (frm.elements['column'+i].value != '') specimenTube.column = frm.elements['column'+i].value;
		if (frm.elements['operatorComment'+i].value != '') specimenTube.operatorComment = frm.elements['operatorComment'+i].value;
		if (frm.specimenType.value != '') specimenTube.specimenType = frm.specimenType.value;
		if (frm.biopsyType.value != '') specimenTube.biopsyType = frm.biopsyType.value;
		
		caseInfo.specimen[i] = specimenTube;
	}

	var submitInfo = new Object();
	submitInfo.caseInfo = caseInfo;

	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var request = Ajax.getXmlHttpRequest();
	var url = '../SpecimenTubeRegistration.servlet?ID=<%=ID%>&cmd=';
	url += 'CreateSpecimenTubes';
	request.open("POST", url, false);
	request.setRequestHeader("Content-Type", "application/json");
	request.send(JSON.stringify(submitInfo));

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}

	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	msg += '<p></p>';
	msg += '<div id=restartSection><i>Wizard will restart automatically...</i></div>';
	setInnerHTML('done', msg);
	Main.show('done');
	Main.show('gostop');
	restartTimer = setTimeout('goRestart(true)',2000);
}

function getCaseInfo()
{
	var frm = document.forms['reggie'];	
	var caseName = frm.caseName.value;
	var request = Ajax.getXmlHttpRequest();
	var url = '../SpecimenTubeRegistration.servlet?ID=<%=ID%>&cmd=GetCaseInfo';
	url += '&caseName=' + caseName;
	request.open("GET", url, false);
	request.send(null);

	if (debug) Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	caseInfo = response.caseInfo;
}

function goStop()
{
	clearTimeout(restartTimer);
	Main.hide('restartSection');
	Main.hide('gostop');
	Main.show('gorestart');
}
</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Specimen tube registration" 
		/></p:path>
	
	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Enter Case Name</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Case name</td>
				<td class="input"><input type="text" name="caseName" 
					size="18" maxlength="12" onkeypress="doOnTabOrEnter(event, goNextAuto)"></td>
				<td class="status" id="case.status"></td>
				<td class="help"><span id="case.message" class="message" style="display: none;"></span>The 7-digit case (barcode) associated with this specimen tube.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div id="caseSection" style="display: none;">
	<p></p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">2</td>
		<td id="step2.title" class="steptitle">Enter Case information</td>
	</tr>
	<tr>
		<td class="stepfields">
		<table border="0" cellspacing="0" cellpadding="0" width="100%">
		<tr>
			<td class="prompt">Number of tubes</td>
			<td class="input"><input type="text" name="nofTubes"
				onkeypress="focusOnEnter(event, 'arrivalDate'); return Numbers.integerOnly(event);" value="1" size="12" maxlength="10" onblur='nofTubesOnChange()'></td>
			<td class="status" id="nofTubes.status"></td>
			<td class="help"><span id="nofTubes.message" class="message" style="display:none"></span>Number of tubes in this case.</td>
		</tr>
		<tr valign="top">
			<td class="prompt">Arrival date</td>
			<td class="input"><input type="text" name="arrivalDate"
				onkeypress="focusOnEnter(event, 'samplingDate')" value="" size="12" maxlength="10" onblur="arrivalDateOnBlur()"></td>
			<td class="status" id="arrivalDate.status"></td>
			<td class="help"><span id="arrivalDate.message" class="message" style="display:none"></span>Date when the specimen tubes arrived(YYYYMMDD or MMDD).</td>
		</tr>
		<tr id="samplingDateSection" valign="top">
			<td class="prompt">Sampling date</td>
			<td class="input"><input type="text" name="samplingDate" value="" size="12" maxlength="10" 
					onkeypress="focusOnEnter(event, 'samplingTime')" onblur="samplingDateTimeOnChange()">
				Time <input type="text" name="samplingTime" value="" size="6" maxlength="4" 
					onkeypress="focusOnEnter(event, 'rnaLaterDate')" onblur="samplingDateTimeOnChange()"></td>
			<td class="status" id="samplingDate.status"></td>
			<td class="help"><span id="samplingDate.message" class="message" style="display: none;"></span>Date+time of surgical removal (YYYYMMDD, HHMM or MMDD, HMM)</td>
		</tr>
		<tr id="rnaLaterDateSection" valign="top">
			<td class="prompt">RNA Later date</td>
			<td class="input"><input type="text" name="rnaLaterDate" value="" size="12" maxlength="10"
					onkeypress="focusOnEnter(event, 'rnaLaterTime')" onblur="rnaLaterDateTimeOnChange()">
				Time <input type="text" name="rnaLaterTime" value="" size="6" maxlength="4"
					onkeypress="focusOnEnter(event, 'specimenType')" onblur="rnaLaterDateTimeOnChange()"></td>
			<td class="status" id="rnaLaterDate.status"></td>
			<td class="help"><span id="rnaLaterDate.message" class="message" style="display: none;"></span>Date+time of pathology handling (YYYYMMDD, HHMM or MMDD, HMM)</td>
		</tr>
		<tr>
			<td class="prompt" id="laterality.prompt">Laterality</td>
			<td class="input" id="laterality.input">
				<label id="lateralityLeft"><input type="radio" name="laterality" value="LEFT" onclick="lateralityOnChange()">LEFT<br></label>
				<label id="lateralityRight"><input type="radio" name="laterality" value="RIGHT" onclick="lateralityOnChange()">RIGHT<br></label>
				<label id="lateralityUnknown"><input type="radio" name="laterality" value="" checked onclick="lateralityOnChange()"><i>unknown</label></i>
				<span id="lateralityFromCase" style="display: none; font-style: italic;">(From existing case)</span>
			</td>
			<td class="status" id="laterality.status"></td>
			<td class="help"><span id="laterality.message" class="message" style="display: none;"></span></td>
		</tr>
		<tr>
			<td class="prompt" id="specimenType.prompt">Specimen type</td>
			<td class="input" id="specimenType.input">
				<select onkeypress="focusOnEnter(event, 'biopsyType')" 
					name="specimenType" onChange="specimenTypeOnClick()"
				>
					<option selected value="" >unknown
					<option value="Primary">Primary
					<option value="LymfnodeRegional">LymfnodeRegional					
					<option value="MetastasisDistant">MetastasisDistant
					<option value="RecurrenceLocal">RecurrenceLocal
					<option value="RecurrenceRegional">RecurrenceRegional					
				</select>
			</td>
			<td class="status" id="specimenType.status"></td>
			<td class="help"><span id="specimenType.message" class="message" style="display: none;"></span></td>
		</tr>
		<tr>
			<td class="prompt" id="biopsyType.prompt">Biopsy type</td>
			<td class="input" id="biopsyType.input">
				<select onkeypress="focusOnEnter(event, 'otherPathNote')" 
					name="biopsyType" onChange="biopsyTypeOnClick()"
				>
					<option selected value="" >unknown
					<option value="SpecimenSurgery">SpecimenSurgery
					<option value="SpecimenCoreBiopsy">SpecimenCoreBiopsy
					<option value="SpecimenFineNeedleAspiration" >SpecimenFineNeedleAspiration
				</select>
			</td>
			<td class="status" id="biopsyType.status"></td>
			<td class="help"><span id="biopsyType.message" class="message" style="display: none;"></span></td>
		</tr>
		
		<tr>
			<td class="prompt" id="otherPathNote.prompt">Other path note</td>
			<td class="input" id="otherPathNote.input"><textarea rows="3" cols="30" 
				name="otherPathNote" value="" onkeypress="doOnTab(event, goNextAuto)"></textarea></td>
			<td class="status" id="otherPathNote.status"></td>
			<td class="help"><span id="otherPathNote.message" class="message" style="display: none;"></span></td>
		</tr>
		</table>
		</td>
			
	</tr>
	</table>
	</div>
	
	<div id="tubeSection" style="display:none;">
	<p></p>
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">3</td>
		<td class="steptitle">Enter tube information</td>		
	</tr>
	<tr>
		<td class="stepfields">
			<table id="tubeInputs" border="0" cellspacing="0" cellpadding="0" width="100%">
			</table>
		</td>
	</tr>
	</table>
	</div>	
		
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="goupdate" title="Update" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>			
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td><base:button id="gostop" title="Stop" image="<%=home+"/images/cancel.png"%>" onclick="goStop()" style="display:none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>